#!/usr/bin/perl

#----------------------------------------------------------------------
# heading     : Telephony
# description : Day/night Timers
# navigation  : 4000 4825
#
# Copyright (c)selintra.com         2005
#
#----------------------------------------------------------------------
#----------------------------------------------------------------------
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
#
# Technical support for this program is available from Selintra Ltd
# Please visit our web site www.selintra.com/ for details.
#----------------------------------------------------------------------

use lib '/opt/sark/perl/modules';

use strict;
use CGI ':all';
use CGI::Carp qw(fatalsToBrowser);

use sark::SarkSubs;

sub showInitial ($$);

sub commit ($);

sub createdateSeg ($);
sub performCreatedateSeg ($);

sub performDelete ($);


BEGIN
{
    # Clear PATH and related environment variables so that calls to
    # external programs do not cause results to be tainted. See
    # "perlsec" manual page for details.

    $ENV {'PATH'} = '';
    $ENV {'SHELL'} = '/bin/bash';
    delete $ENV {'ENV'};
}

#esmith::util::setRealToEffective ();
$< = $>;
$( = $);

$CGI::POST_MAX=1024 * 100;  # max 100K posts
$CGI::DISABLE_UPLOADS = 1;  # no uploads

my $editicon = "<img src=\"/sark-common/edit.png\" border=0 title = \"@{[SarkSubs::tt_display('Sarkedittext')]}\">";
my $yesicon = "<img src=\"/sark-common/connected.png\" border=0 title = \"@{[SarkSubs::tt_display('Sarktinfotext')]}\">";
my $noicon = "<img src=\"/sark-common/actions/no.png\" border=0 title = \"@{[SarkSubs::tt_display('Sarkoffline')]}\" >";
my $warnicon = "<img src=\"/sark-common/warning.png\" border=0 title = \"@{[SarkSubs::tt_display('Sarkwarntext')]}\" >";
my $infoicon = "<img src=\"/sark-common/info.png\" border=0 >";
my $greenicon = "<img src=\"/sark-common/actions/apply.png\" border=0 title = \"@{[SarkSubs::tt_display('Sarkremotetext')]}\" >";
my $activeicon = "<img src=\"/sark-common/actions/apply.png\" border=0 title = \"@{[SarkSubs::tt_display('Sarkactivetext')]}\" >";
my $monicon = "<img src=\"/sark-common/actions/apply.png\" border=0 title = \"@{[SarkSubs::tt_display('Sarkmontext')]}\" >";
my $trashicon = "<img src=\"/sark-common/edittrash.png\" border=0 onclick=\"return confirmOK('Delete this Object - Confirm?')\" title = \"@{[SarkSubs::tt_display('Sarkdeletetext')]}\" >";

my %dateSeg;
my %hashScrnVars;
my @Verrors;
my $gonogo = 0;
my $cfwd;
my %hashVarDefaults = (
	"cluster"       => 'default',
        "datemonth"	=> undef,
        "dayofweek"	=> undef,
        "desc"		=> undef,
        "month"		=> undef,
        "timespan"	=> undef,
        "pkey" 		=> undef,
	);
my %hashVarErrors;
my %hashVarOutBuf = (
	"cluster"       => undef,
        "datemonth"	=> undef,
        "dayofweek"	=> undef,
        "desc"		=> undef,
        "month"		=> undef,
        "timespan"	=> undef,
        "pkey" 		=> undef,
        );
my %hashVarUpdBuf = ();
my %hashVarRegexs = (
    	"AADEFAULT" => qr/(.*)/,
        );
my %hashColorDefaults = %hashVarDefaults;
while ( my $tk = each %hashColorDefaults ) {
        $hashColorDefaults{$tk} = 'black';
}

my @quarter_hours = qw/* 00:00   00:15   00:30   00:45
                        01:00   01:15   01:30   01:45
                        02:00   02:15   02:30   02:45
                        03:00   03:15   03:30   03:45
                        04:00   04:15   04:30   04:45
                        05:00   05:15   05:30   05:45
                        06:00   06:15   06:30   06:45
                        07:00   07:15   07:30   07:45
                        08:00   08:15   08:30   08:45
                        09:00   09:15   09:30   09:45
                        10:00   10:15   10:30   10:45
                        11:00   11:15   11:30   11:45
                        12:00   12:15   12:30   12:45
                        13:00   13:15   13:30   13:45
                        14:00   14:15   14:30   14:45
                        15:00   15:15   15:30   15:45
                        16:00   16:15   16:30   16:45
                        17:00   17:15   17:30   17:45
                        18:00   18:15   18:30   18:45
                        19:00   19:15   19:30   19:45
                        20:00   20:15   20:30   20:45
                        21:00   21:15   21:30   21:45
                        22:00   22:15   22:30   22:45
                        23:00   23:15   23:30   23:45 /;
my @month_days =   qw/* 1 2 3 4 5 6
                      7 8 9 10 11 12
                      13 14 15 16 17 18
                      19 20 21 22 23 24
                      25 26 27 28 29 30 31/;
my @year_months = qw/* jan feb mar apr may jun jul aug sep oct nov dec/;

my $pages = 1 ;
my $page = 1;
my $epages = 1;
my $epage = 1;

#
#
#

my $q = new CGI;

my %params = $q->Vars;
#
#  Retrieve the page number
#
for my $key ( keys %params ) {
       if ( $key =~ /^page(\d{1,}).x$/ ) {
       	  $page=$1;
          showInitial ($q, '');
          exit(0);
       }
       if ( $key =~ /^epage(\d{1,}).x$/ ) {
       	  $epage=$1;
          linesIn ($q);
          exit(0);
       }
}

if ($q->param ('delete.x') ) {
    performDelete ($q);
}
elsif ($q->param ('initcommit.x') ) {
        commit ($q);
}
elsif ($q->param ('cancel.x') ) {
    showInitial ($q, '');
}
elsif ($q->param ('commit.x') ) {
    performCreatedateSeg ($q);
}
elsif ($q->param ('save.x') ) {
    performCreatedateSeg ($q);
}
elsif ($q->param ('new.x') ) {
	createdateSeg ($q);
}
#elsif ($q->param ('undo.x'))
#{
#    SarkSubs::SQLiteUndo();
#    $q->delete_all();
#    showInitial ($q,"Undo Processing complete");
#}
elsif (! grep (/^state$/, $q->param)) {
    showInitial ($q, '');
}

elsif ($q->param ('state') eq "create") {
    createdateSeg ($q);
}
elsif ($q->param ('state') eq "performCreatedateSeg") {
    performCreatedateSeg ($q);
}
else {
    die "State error";
}

exit (0);

sub showInitial ($$)
{
   my ($q, $msg) = @_;
   my $dbh = SarkSubs::SQLiteConnect();
   my $commit = SarkSubs::SQLiteGet($dbh, "SELECT MYCOMMIT FROM globals where pkey = 'global'");
   my @dateSeg = sort (SarkSubs::SQLiteGetKeys($dbh, "SELECT pkey FROM dateSeg" ));

   SarkSubs::sark_header ($q);
   my $numlines = @dateSeg;
   my $remainder = $numlines % 12;
   $pages = int($numlines / 12);
   if ($remainder) {
    	$pages++;
   }
   my $linelow = (($page-1) * 12);
   my $linehigh = $linelow + 12;
   print h1( SarkSubs::tt_display('Sarksystemh11').($msg || 'Day/Night Timers') );
   print '<hr class="hr" />';

   print '<div class="buttons">';
   SarkSubs::sark_button_new();
   SarkSubs::sark_button_commit("initcommit",$commit);
#   if (SarkSubs::SQLiteCheckUndo) {
#        	SarkSubs::sark_button_undo();
#   }
   print '</div>';


   print '<div>';
   unless (@dateSeg) {
        print '<span style="color:red;font-weight:bold">'.SarkSubs::tt_display('Sarkautomsg1').'</span>';
        print '</div>';
        SarkSubs::sark_footer($q);
        SarkSubs::SQLiteDisconnect($dbh);
        exit(0);
    }
   print $q->table ({border => 1, cellspacing => 1, cellpadding => 4});

   print $q->Tr (
                  $q->th({class=>"srk-border"}, SarkSubs::aHeaderFor('cluster')),
                  $q->th({class=>"srk-border"}, SarkSubs::aHeaderFor('timespan')),
                  $q->th({class=>"srk-border"}, SarkSubs::aHeaderFor('weekday')),
                  $q->th({class=>"srk-border"}, SarkSubs::aHeaderFor('datemonth')),
                  $q->th({class=>"srk-border"}, SarkSubs::aHeaderFor('month')),
                  $q->th({class=>"srk-border"}, SarkSubs::aHeaderFor('description')),
                  $q->th({class=>"srk-border"}, ''),
                  $q->th({class=>"srk-border"}, '')
                  );

   my $rowcolor = 0x01;
   my $i = $linelow;;
   while ($i<$linehigh && $i <= $#dateSeg) {
        my $pkey = $dateSeg[$i];
        %dateSeg = SarkSubs::SQLiteGetHash($dbh, "SELECT * FROM dateSeg WHERE pkey = '$pkey'");
        print $q->Tr ({-class => "d".$rowcolor},
        	    $q->td({class=>"srk-border"}, $dateSeg{cluster}),
		    $q->td({class=>"srk-border"}, $dateSeg{timespan}),
                    $q->td({class=>"srk-border"}, $dateSeg{dayofweek}),
                    $q->td({class=>"srk-border"}, $dateSeg{datemonth}),
                    $q->td({class=>"srk-border"}, $dateSeg{month}),
                    $q->td({class=>"srk-border"}, $dateSeg{desc}),
              	    $q->td({class=>"srk-border"},
               		$q->a ({href => $q->url (-absolute => 1)
                       	. "?state=create&change=yes&pkey=$pkey"},
	 			$editicon)),
                    $q->td({class=>"srk-border"},
                     	$q->a ({href => $q->url (-absolute => 1)
                        . "?state=create&delete=yes&pkey=$pkey"},
				$trashicon)));
        $rowcolor = $rowcolor ^ 1;
        $i++;
   }
   print '</table>';
   SarkSubs::printpages($pages, $page);
   print '</div>';
   print '</div>';
   SarkSubs::sark_footer($q);
   SarkSubs::SQLiteDisconnect($dbh);
}

sub commit ($)
{
    SarkSubs::sysCommit($q);
    showInitial ($q, "<font color = red>@{[SarkSubs::tt_display('Sarksystemmsg1')]}</font color = red><font color = black>");
}

sub createdateSeg ($)
{
    my ($q) = @_;
    my $pkey     = $q->param ('pkey');
    my $delete   = $q->param ('delete');
    my $new      = $q->param ('new.x');
    my $dbh = SarkSubs::SQLiteConnect();
    my $starthour = "*";
    my $endhour = "*";
    if ($delete eq 'yes') {
        performDelete($q);
    	return 0;
    }
    if ($q->param ('new.x') ) {
       my $random = int(rand(999999));
       $pkey = 'dateSeg'.$random;
    }
    else {
    	%dateSeg = SarkSubs::SQLiteGetHash($dbh, "SELECT * FROM dateSeg WHERE pkey = '$pkey'");
    	if ($dateSeg{timespan} =~/^(\d{2}:\d{2})/)  {
    		$starthour = $1;
    	}
    	else {
        	$starthour = "*";
    	}
    	if ($dateSeg{timespan} =~ /(\d{2}:\d{2})$/) {
        	$endhour = $1;
    	}
    	else {
        	$endhour = "*";
    	}
    }
    my @Clusters = sort (SarkSubs::SQLiteGetKeys($dbh, "SELECT pkey FROM Cluster"));

    SarkSubs::sark_header ($q);
    print h1( SarkSubs::tt_display('Sarksystemh11')."Timer $pkey" );

    print '<hr class="hr" />';


    if (@Verrors) {
	SarkSubs::sark_error(\@Verrors);
    }
    print '<div class="buttons">';
    SarkSubs::sark_button_cancel();
    SarkSubs::sark_button_save("save");
    SarkSubs::sark_button_commit( "commit", SarkSubs::SQLiteGet($dbh, "SELECT MYCOMMIT FROM globals where pkey = 'global'") );
    print '</div>';


    print '<div>';
#    print "<div class=\"notes\">
#        <h4>Route Details</h4>
#        <p class=\"last\">These are the details for the Timer you selected. You may freely modify the unprotected variables...";
#    print '</p></div>';


    print SarkSubs::aLabelFor('beginclosed');
    print $q->popup_menu (
                     -name    => 'starthour',
                     -values  => [@quarter_hours],
                     -default => $starthour);
    print SarkSubs::aLabelFor('endclosed');
    print $q->popup_menu (
                     -name    => 'endhour',
                     -values  => [@quarter_hours],
                     -default => $endhour);
    print SarkSubs::aLabelFor('weekday');
    print $q->popup_menu (
                     -name    => 'dayofweek',
                     -values  => ["mon","tue","wed","thu","fri","sat","sun","*"],
                     -default => $dateSeg{dayofweek});
    print SarkSubs::aLabelFor('datemonth');
    print $q->popup_menu (
                     -name    => 'datemonth',
                     -values  => [@month_days],
                     -default => $dateSeg{datemonth});
    print SarkSubs::aLabelFor('month');
    print $q->popup_menu (
                     -name    => 'month',
                     -values  => [@year_months],
                     -default => $dateSeg{month});
    my $clusterdefault = $dateSeg{cluster} || 'default';
    print SarkSubs::aLabelFor('cluster');
    print $q->popup_menu (
                        -name     => 'cluster',
                        -values   => [@Clusters],
                        -default  => $clusterdefault);
    print SarkSubs::aLabelFor('description');
    print $q->textfield (
                    -name     => 'desc',
                    -default  => $dateSeg{desc},
                    -size     => 20);

    print "</div>";

    print $q->hidden (-name => 'pkey',  -override => 1, -default => $pkey);
    print $q->hidden (-name => 'new.x', -override => 1, -default => $new);
    print $q->hidden (-name => 'state', -override => 1, -default => 'performCreatedateSeg');

    SarkSubs::sark_footer($q);
    SarkSubs::SQLiteDisconnect($dbh);
}


sub performCreatedateSeg ($)
{
	my ($q) = shift;
        my $response;
        my %hashScrnVars = $q->Vars ;
        my $dbh = SarkSubs::SQLiteConnect();

    	if ($hashScrnVars{starthour} eq "*" || $hashScrnVars{endhour} eq "*") {
         	$hashScrnVars{timespan} = "*";
        }
    	else {
         $hashScrnVars{timespan} = $hashScrnVars{starthour}."-".$hashScrnVars{endhour};
        }
        if ( $q->param('new.x') ) {
                my %hashRecordColumns = SarkSubs::SQLiteGetHashCols($dbh, 'dateSeg');
#        	SarkSubs::SQLiteDisconnect($dbh);
        	$gonogo = SarkSubs::validateTuple(\%hashScrnVars, \%hashRecordColumns, \%hashVarRegexs,
    			\%hashVarOutBuf, \%hashColorDefaults,
                        \@Verrors);
		unless ($gonogo) {
#
#		Set defaults
#
        		while ( my ($key, $value) = each %hashVarDefaults ) {
                		unless ( $hashVarOutBuf{$key} ) {
                        		if ($hashVarDefaults{$key}) {
                        			$hashVarOutBuf{$key} = $hashVarDefaults{$key};
                                	}
                        	}
                	}
#
#		Create record
#
#        		my $dbh = SarkSubs::SQLiteConnect();
        		SarkSubs::newTuple( \%hashVarOutBuf, "dateSeg", $dbh);
                        $response = "Timer Created!";
                }
        }
        else {
             	%dateSeg = SarkSubs::SQLiteGetHash($dbh, "SELECT * FROM dateSeg WHERE pkey = '$hashScrnVars{pkey}'");
        	$gonogo = SarkSubs::validateTuple(\%hashScrnVars, \%dateSeg, \%hashVarRegexs,
    			\%hashVarUpdBuf, \%hashColorDefaults,
                        \@Verrors);
        	unless ( $gonogo ) {
    			SarkSubs::updateTuple (\%hashVarUpdBuf, \%dateSeg, "dateSeg", $dbh);
                        $response = "Timer Updated!";
    		}
        }
        SarkSubs::SQLiteDisconnect($dbh);
    	if ( $gonogo ) {
    		createdateSeg($q);
        	return 0;
    	}
    	if ($q->param('commit.x')) {
        	SarkSubs::sysCommit($q);
    	}
    	showInitial ($q,$response);
    	return 0;
}


#sub unDo ($)
#
#{
#    my ($q) = @_;
#    SarkSubs::SQLiteUndo();
#    SarkSubs::signalOK($q, "Undo Processing complete  - click the arrow to continue...");
#    showInitial ($q,"Undo Processing complete");
#}

sub performDelete ($)
{
    my ($q) = shift;
    my $pkey = $q->param ('pkey');
    my $dbh = SarkSubs::SQLiteConnect();
    SarkSubs::SQLiteDo($dbh, "UPDATE globals SET MYCOMMIT='YES' WHERE pkey='global'");
    SarkSubs::SQLiteDelete($dbh,"DELETE FROM dateSeg where pkey='$pkey'");
    SarkSubs::SQLiteCommit($dbh);
    SarkSubs::SQLiteDisconnect($dbh);
    showInitial ($q, "<font color = red>Successfully deleted Timer $pkey</font color = red><font color = black>");
}
