#!/usr/bin/perl

#----------------------------------------------------------------------
# heading     : Telephony
# description : Multi-tenant
# navigation  : 4000 4837
#
# Copyright (c) selintra.com         2005
#
#----------------------------------------------------------------------
#----------------------------------------------------------------------
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
#
# Technical support for this program is available from Selintra Ltd
# Please visit our web site www.selintra.com/ for details.
#----------------------------------------------------------------------


use lib '/opt/sark/perl/modules';

use strict;
use CGI ':all';
use CGI::Carp qw(fatalsToBrowser);

use sark::SarkSubs;

sub showInitial ($$);

sub commit ($);

sub createCluster ($);
sub performCreateCluster ($);

sub editCluster ($);
sub performEditCluster ($);

sub performDelete ($);


BEGIN
{
    # Clear PATH and related environment variables so that calls to
    # external programs do not cause results to be tainted. See
    # "perlsec" manual page for details.

    $ENV {'PATH'} = '';
    $ENV {'SHELL'} = '/bin/bash';
    delete $ENV {'ENV'};
}

#esmith::util::setRealToEffective ();
$< = $>;
$( = $);

$CGI::POST_MAX=1024 * 100;  # max 100K posts
$CGI::DISABLE_UPLOADS = 1;  # no uploads


my $editicon = "<img src=\"/sark-common/edit.png\" border=0 title = \"@{[SarkSubs::tt_display('Sarkedittext')]}\">";
my $yesicon = "<img src=\"/sark-common/connected.png\" border=0 title = \"@{[SarkSubs::tt_display('Sarktinfotext')]}\">";
my $noicon = "<img src=\"/sark-common/actions/no.png\" border=0 title = \"@{[SarkSubs::tt_display('Sarkoffline')]}\" >";
my $warnicon = "<img src=\"/sark-common/warning.png\" border=0 title = \"@{[SarkSubs::tt_display('Sarkwarntext')]}\" >";
my $infoicon = "<img src=\"/sark-common/info.png\" border=0 >";
my $greenicon = "<img src=\"/sark-common/actions/apply.png\" border=0 title = \"@{[SarkSubs::tt_display('Sarkremotetext')]}\" >";
my $activeicon = "<img src=\"/sark-common/actions/apply.png\" border=0 title = \"@{[SarkSubs::tt_display('Sarkactivetext')]}\" >";
my $monicon = "<img src=\"/sark-common/actions/apply.png\" border=0 title = \"@{[SarkSubs::tt_display('Sarkmontext')]}\" >";
my $trashicon = "<img src=\"/sark-common/edittrash.png\" border=0 onclick=\"return confirmOK('Delete this Object - Confirm?')\" title = \"@{[SarkSubs::tt_display('Sarkdeletetext')]}\" >";

my %Cluster;
my %hashScrnVars;
my @Verrors;
my $gonogo = 0;
my $cfwd;
my %hashVarDefaults = (
#        "callgroup"	=> undef,
        "include"	=> undef,
        "masteroclo"	=> undef,
        "oclo"		=> undef,
        "operator"	=> undef,
#        "pickupgroup"	=> undef,
        "pkey" 		=> undef,
        "abstimeout" => undef,
        "chanmax" => undef,
	);
my %hashVarErrors;
my %hashVarOutBuf = (
#        "callgroup"	=> undef,
        "include"	=> undef,
        "masteroclo"	=> undef,
        "oclo"		=> undef,
        "operator"	=> undef,
#        "pickupgroup"	=> undef,
        "pkey" 		=> undef,
        "abstimeout" => undef,
        "chanmax" => undef,
        );
my %hashVarUpdBuf = ();
my %hashVarRegexs = (
    	"AADEFAULT" => qr/(.*)/,
#        "pickupgroup"  	=> qr/^([\d{1,2}\-,\s]+)$/,
#        "callgroup"  	=> qr/^(\d{1,2}|\s+)$/,
		"abstimeout"  	=> qr/^(\d{1,5})$/,
		"chanmax"  	=> qr/^(\d{1,3})$/,
        "include"  	=> qr/^([\w\s-]+|ALL)$/,
        );
my %hashColorDefaults = %hashVarDefaults;
while ( my $tk = each %hashColorDefaults ) {
        $hashColorDefaults{$tk} = 'black';
}

my $pages = 1 ;
my $page = 1;
my $epages = 1;
my $epage = 1;

#
#
#

my $q = new CGI;

my %params = $q->Vars;


if ($q->param ('new.x') )
{
	createCluster ($q);
}

elsif ($q->param ('phase1.x') )
{
	performCreateCluster ($q);
}
elsif ($q->param ('delete.x') )
{
	performDelete ($q);
}
elsif ($q->param ('state') eq "linesIn")
{
    editCluster ($q);
}

elsif ($q->param ('upsave.x') )
{
    performEditCluster ($q);
}

elsif ($q->param ('initcommit.x') )
{
        commit ($q);
}

elsif ($q->param ('newcommit.x') )
{
        performCreateCluster ($q);
}

elsif ($q->param ('commit.x') )
{
    performEditCluster ($q);
}

#elsif ($q->param ('undo.x'))
#{
#    SarkSubs::SQLiteUndo();
#    $q->delete_all();
#    showInitial ($q,"Undo Processing complete");
#}

elsif (! grep (/^state$/, $q->param))
{
    showInitial ($q, '');
}

elsif ($q->param ('cancel.x') )
{
    showInitial ($q, '');
}


#other
elsif ($q->param ('state') eq "performDelete")
{
    performDelete ($q);
}

else
{
    die "STATE ERROR";
}

exit (0);


sub showInitial ($$)
{
    my ($q, $msg) = @_;
    my $dbh = SarkSubs::SQLiteConnect();
    my $commit = SarkSubs::SQLiteGet($dbh, "SELECT MYCOMMIT FROM globals where pkey = 'global'");
    my @Cluster = sort (SarkSubs::SQLiteGetKeys($dbh, "SELECT pkey FROM Cluster" ));

    SarkSubs::sark_header ($q);
    my $numlines = @Cluster;
    my $remainder = $numlines % 12;
    $pages = int($numlines / 12);
    if ($remainder) {
    	$pages++;
    }
    my $linelow = (($page-1) * 12);
    my $linehigh = $linelow + 12;
    print h1( SarkSubs::tt_display('Sarksystemh11').($msg || 'Multi-Tenants') );
    print '<hr class="hr" />';


    print '<div class="buttons">';
    SarkSubs::sark_button_new();
    SarkSubs::sark_button_commit("initcommit", $commit);
 #   if (SarkSubs::SQLiteCheckUndo) {
 #       SarkSubs::sark_button_undo();
 #   }
    print '</div>';


    print "<div class=etabs>";
    
    if ( @Cluster == 1) {
        print '<span style="color:red;font-weight:bold">'.SarkSubs::tt_display('Sarkclustermsg1').'</span>';
        print '</div>';
        SarkSubs::sark_footer($q);
        SarkSubs::SQLiteDisconnect($dbh);
        exit(0);
    }
    print $q->table ({border => 1, cellspacing => 1, cellpadding => 4});

    print $q->Tr (
               $q->th({class=>"srk-border"}, SarkSubs::aHeaderFor('tenantname')),
               $q->th({class=>"srk-border"}, SarkSubs::aHeaderFor('tenantoperator')),
               $q->th({class=>"srk-border"}, SarkSubs::aHeaderFor('ato')),
               $q->th({class=>"srk-border"}, SarkSubs::aHeaderFor('chanmax')),
               $q->th({class=>"srk-border"}, SarkSubs::aHeaderFor('oclo')),
               $q->th({class=>"srk-border"}, ''),
               $q->th({class=>"srk-border"}, '')
               );

    my $rowcolor = 0x01;
#    my $i = $linelow;;
#    while ($i<$linehigh && $i <= $#Cluster) {
#        my $pkey = $Cluster[$i];
	 foreach (@Cluster) {
		my $pkey = $_;  
    # Don't publish the default cluster
    	unless ($pkey =~ /^default$/) {
            %Cluster = SarkSubs::SQLiteGetHash($dbh, "SELECT * FROM Cluster WHERE pkey = '$pkey'");
            print $q->Tr ({-class => "d".$rowcolor},
            	    $q->td({class=>"srk-border"}, $pkey),
            	    $q->td({class=>"srk-border"}, $Cluster{operator}),
            	    $q->td({class=>"srk-border"}, $Cluster{abstimeout}),
            	    $q->td({class=>"srk-border"}, $Cluster{chanmax}),
            	    $q->td({class=>"srk-border"}, $Cluster{oclo}),
                    $q->td({class=>"srk-border"},
                    	$q->a ({href => $q->url (-absolute => 1)
                        . "?state=linesIn&change=yes&pkey=$pkey"},
				$editicon)),
                    $q->td({class=>"srk-border"},
                        $q->a ({href => $q->url (-absolute => 1)
                        . "?state=linesIn&delete=yes&pkey=$pkey"},
			   	$trashicon)));
            $rowcolor = $rowcolor ^ 1;
        }
    }

    print $q->end_table;
#    SarkSubs::printpages($pages, $page);
    print '</div>';
    SarkSubs::sark_footer($q);
    SarkSubs::SQLiteDisconnect($dbh);

}

sub commit ($)
{
    SarkSubs::sysCommit($q);
    showInitial ($q, "<font color = red>@{[SarkSubs::tt_display('Sarksystemmsg1')]}</font color = red><font color = black>");
}

sub createCluster ($)
{
    my $dbh = SarkSubs::SQLiteConnect();
    my @Clusters = sort (SarkSubs::SQLiteGetKeys($dbh, "SELECT pkey FROM Cluster"));
    my @Exts = sort (SarkSubs::SQLiteGetKeys($dbh, "SELECT pkey FROM IPphone" ));
    SarkSubs::sark_header ($q);
    print h1( SarkSubs::tt_display('Sarksystemh11')."Create a new Tenant" );
    print '<hr class="hr" />';

    if (@Verrors) {
	SarkSubs::sark_error(\@Verrors);
    }
    print '<div class="buttons">';
    SarkSubs::sark_button_cancel();
    SarkSubs::sark_button_save("phase1");
    SarkSubs::sark_button_commit( "newcommit", SarkSubs::SQLiteGet($dbh, "SELECT MYCOMMIT FROM globals where pkey = 'global'") );
    print '</div>';


    print '<div>';
#    print "<div class=\"notes\">
#        <h4>Tenant</h4>
#        <p class=\"last\">Enter the details for your new Tenant.</p>
#    	</div>";

    print SarkSubs::aLabelFor('tenantname');
    print $q->textfield (
                    -name     => 'pkey',
                    -override => 1,
                    -style    => "color: $hashColorDefaults{pkey}",
                    -default  => $hashScrnVars{pkey},
                    -size     => 10);
    print SarkSubs::aLabelFor('includetenants');
    print $q->textfield (
                    -name     => 'include',
                    -override => 1,
                    -style    => "color: $hashColorDefaults{include}",
                    -default  => $hashScrnVars{include},
                    -size     => 20);
    print SarkSubs::aLabelFor('tenantoperator');
    print $q->popup_menu (
                    -name     => 'operator',
                    -values   => ['System Operator', @Exts]);
                    
    print SarkSubs::aLabelFor('abstimeout');
    print $q->textfield (
                    -name     => 'abstimeout',
                    -default  => 14400,
                    -size     => 5);                
                    
    print SarkSubs::aLabelFor('chanmax');
    print $q->textfield (
                    -name     => 'chanmax',
                    -default  => 3,
                    -size     => 2);                           
                    
#                    -default  => 'System Operator');
#    print SarkSubs::aLabelFor('cgroup');
#    print $q->textfield (
#                    -name     => 'callgroup',
#                    -override => 1,
#                    -default  => $hashScrnVars{callgroup},
#                    -style    => "color: $hashColorDefaults{callgroup}",
#                    -size     => 2);
#    print SarkSubs::aLabelFor('pickupgroup');
#    print $q->textfield (
#                    -name     => 'pgroup',
#                    -override => 1,
#                    -default  => $hashScrnVars{pickupgroup},
#                    -style    => "color: $hashColorDefaults{pickupgroup}",
#                    -size     => 4);
    print "</div>";

    SarkSubs::sark_footer($q);
    SarkSubs::SQLiteDisconnect($dbh);
}


sub performCreateCluster ($)
{
    	my ($q) = shift;
    	%hashScrnVars = $q->Vars;
        my $dbh = SarkSubs::SQLiteConnect();
        my %hashRecordColumns = SarkSubs::SQLiteGetHashCols($dbh, 'Cluster');
        SarkSubs::SQLiteDisconnect($dbh);
        $gonogo = SarkSubs::validateTuple(\%hashScrnVars, \%hashRecordColumns, \%hashVarRegexs,
    			\%hashVarOutBuf, \%hashColorDefaults,
                        \@Verrors);
	unless ($gonogo) {
#
#		Set defaults
#
        	while ( my ($key, $value) = each %hashVarDefaults ) {
                	unless ( $hashVarOutBuf{$key} ) {
                        	if ($hashVarDefaults{$key}) {
                        		$hashVarOutBuf{$key} = $hashVarDefaults{$key};
                                }
                        }
                }
#
#		Create record
#
        	my $dbh = SarkSubs::SQLiteConnect();
        	SarkSubs::newTuple( \%hashVarOutBuf, "Cluster", $dbh);
                SarkSubs::SQLiteDisconnect($dbh);
       		if ( $hashScrnVars{'newcommit.x'} ) {
    			SarkSubs::sysCommit($q);
    		}
                showInitial ($q,"Entry Created!");
    	}
        else {
        	createCluster ($q);
        }
        return 0;
}

sub editCluster ($)
{
    my ($q) 	= shift;
    my %hashScrnVars = $q->Vars ;
    my $delete   = $q->param ('delete');
    my $change   = $q->param ('change');
    my $pkey 	 = $q->param ('pkey');
    if ($delete eq 'yes') {
        performDelete($q);
    	return 0;
    }

    my $dbh = SarkSubs::SQLiteConnect();
    my $commit = SarkSubs::SQLiteGet($dbh, "SELECT MYCOMMIT FROM globals where pkey = 'global'");
    %Cluster = SarkSubs::SQLiteGetHash($dbh, "SELECT * FROM Cluster WHERE pkey = '$pkey'");
    my @Exts = sort (SarkSubs::SQLiteGetKeys($dbh, "SELECT pkey FROM IPphone" ));

    SarkSubs::sark_header ($q);
    print h1( SarkSubs::tt_display('Sarksystemh11')."Modify Tenant $pkey" );
    print '<hr class="hr" />';

    if (@Verrors) {
	SarkSubs::sark_error(\@Verrors);
    }
    print '<div class="buttons">';
    SarkSubs::sark_button_cancel();
    SarkSubs::sark_button_save("upsave");
    SarkSubs::sark_button_commit( "commit", SarkSubs::SQLiteGet($dbh, "SELECT MYCOMMIT FROM globals where pkey = 'global'") );
    print '</div>';

    print '<div>';
#    print "<div class=\"notes\">
#        <h4>Tenant</h4>
#        <p class=\"last\">Enter the details for your Tenant.</p>
#    	</div>";

    print SarkSubs::aLabelFor('tenantname');
    print $q->textfield (
                    -name     => 'pkey',
                    -override => 1,
                    -readonly =>'readonly',
                    -style    =>'background-color: lightgrey',
                   -default  => $Cluster{pkey},
                    -size     => 10);
    print SarkSubs::aLabelFor('includetenants');
    print $q->textfield (
                    -name     => 'include',
                    -override => 1,
                    -style    => "color: $hashColorDefaults{include}",
                    -default  => $Cluster{include},
                    -size     => 20);
    print SarkSubs::aLabelFor('tenantoperator');
    print $q->popup_menu (
                    -name     => 'operator',
                    -values   => ['System Operator', @Exts],
                    -default  => $Cluster{operator});
    print SarkSubs::aLabelFor('abstimeout');
    print $q->textfield (
                    -name     => 'abstimeout',
                    -default  => $Cluster{abstimeout},
                    -size     => 5);                                    
    print SarkSubs::aLabelFor('chanmax');
    print $q->textfield (
                    -name     => 'chanmax',
                    -default  => $Cluster{chanmax},
                    -size     => 2);                                      
#    print SarkSubs::aLabelFor('cgroup');
#    print $q->textfield (
#                    -name     => 'callgroup',
#                    -override => 1,
#                    -style    => "color: $hashColorDefaults{callgroup}",
#                    -default  => $Cluster{callgroup},
#                    -size     => 2);
#    print SarkSubs::aLabelFor('pgroup');
#    print $q->textfield (
#                    -name     => 'pickupgroup',
#                    -override => 1,
#                    -style    => "color: $hashColorDefaults{pickupgroup}",
#                    -default  => $Cluster{pickupgroup},
#                    -size     => 4);
#
    print "</div>";
    SarkSubs::sark_footer($q);
    SarkSubs::SQLiteDisconnect($dbh);
}

sub performEditCluster ($)
{
    my $q = shift;
    my %hashScrnVars = $q->Vars ;
    my $response;

    my $dbh = SarkSubs::SQLiteConnect();
    %Cluster = SarkSubs::SQLiteGetHash($dbh, "SELECT * FROM Cluster WHERE pkey = '$hashScrnVars{pkey}'");
    $gonogo = SarkSubs::validateTuple(\%hashScrnVars, \%Cluster, \%hashVarRegexs,
    			\%hashVarUpdBuf, \%hashColorDefaults,
                        \@Verrors);
    unless ( $gonogo ) {
    	SarkSubs::updateTuple (\%hashVarUpdBuf, \%Cluster, "Cluster", $dbh);
    }
    SarkSubs::SQLiteDisconnect($dbh);

    if ( $gonogo ) {
    	editCluster($q);
        return 0;
    }
    if ($q->param('commit.x')) {
        	SarkSubs::sysCommit($q);
                $response = "Committed!";
    }
    showInitial ($q,$response);
    return 0;
}

sub performDelete ($)
{
    my ($q) = shift;
    my $pkey = $q->param ('pkey');
    my $dbh = SarkSubs::SQLiteConnect();
    SarkSubs::SQLiteDo($dbh, "UPDATE globals SET MYCOMMIT='YES' WHERE pkey='global'");
    SarkSubs::SQLiteDelete($dbh,"DELETE FROM Cluster where pkey='$pkey'");
    SarkSubs::SQLiteCommit($dbh);
    SarkSubs::SQLiteDisconnect($dbh);
    showInitial ($q, "<font color = red>Successfully deleted Tenant $pkey</font color = red><font color = black>");
}
