#!/usr/bin/perl

#----------------------------------------------------------------------
# heading     : Telephony
# description : Routes
# navigation  : 4000 4807
#
# Copyright (c) Selintra.com 2005
#
#----------------------------------------------------------------------
#----------------------------------------------------------------------
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
#
# Technical support for this program is available from Selintra Ltd
# Please visit our web site www.selintra.com/ for details.
#----------------------------------------------------------------------



use lib '/opt/sark/perl/modules';

use strict;
use CGI ':all';
use CGI::Carp qw(fatalsToBrowser);

use sark::SarkSubs;

sub showInitial ($$);
sub commit ($);
sub linesIn ($);
sub performCreate ($);
sub performCreateLinesIn ($);
sub performUpdate ($);
sub performDelete ($);


BEGIN
{
    # Clear PATH and related environment variables so that calls to
    # external programs do not cause results to be tainted. See
    # "perlsec" manual page for details.

    $ENV {'PATH'} = '';
    $ENV {'SHELL'} = '/bin/bash';
    delete $ENV {'ENV'};
}

#esmith::util::setRealToEffective ();
$< = $>;
$( = $);

$CGI::POST_MAX=1024 * 100;  # max 100K posts
$CGI::DISABLE_UPLOADS = 1;  # no uploads



my $editicon = "<img src=\"/sark-common/edit.png\" border=0 title = \"@{[SarkSubs::tt_display('Sarkedittext')]}\">";
my $yesicon = "<img src=\"/sark-common/connected.png\" border=0 title = \"@{[SarkSubs::tt_display('Sarktinfotext')]}\">";
my $noicon = "<img src=\"/sark-common/actions/no.png\" border=0 title = \"@{[SarkSubs::tt_display('Sarkoffline')]}\" >";
my $warnicon = "<img src=\"/sark-common/warning.png\" border=0 title = \"@{[SarkSubs::tt_display('Sarkwarntext')]}\" >";
my $infoicon = "<img src=\"/sark-common/info.png\" border=0 >";
my $greenicon = "<img src=\"/sark-common/actions/apply.png\" border=0 title = \"@{[SarkSubs::tt_display('Sarkremotetext')]}\" >";
my $activeicon = "<img src=\"/sark-common/actions/apply.png\" border=0 title = \"@{[SarkSubs::tt_display('Sarkactivetext')]}\" >";
my $monicon = "<img src=\"/sark-common/actions/apply.png\" border=0 title = \"@{[SarkSubs::tt_display('Sarkmontext')]}\" >";
my $trashicon = "<img src=\"/sark-common/edittrash.png\" border=0 onclick=\"return confirmOK('Delete this Object - Confirm?')\" title = \"@{[SarkSubs::tt_display('Sarkdeletetext')]}\" >";

my %Route;
my %hashScrnVars;
my @Verrors;
my $gonogo = 0;
my $cfwd;
my %hashVarDefaults = (
        "active" 	=> "YES",
        "alternate"	=> undef,
        "auth"		=> "NO",
        "cluster"	=> "default",
        "desc"		=> undef,
        "dialplan"	=> undef,
        "path1"		=> "None",
        "path2"		=> "None",
        "path3"		=> "None",
        "path4"		=> "None",
        "pkey" 		=> undef,
	);
my %hashVarErrors;
my %hashVarOutBuf = (
	"active" 	=> undef,
        "alternate"	=> undef,
        "auth"		=> undef,
        "cluster"	=> undef,
        "desc"		=> undef,
        "dialplan"	=> undef,
        "path1"		=> undef,
        "path2"		=> undef,
        "path3"		=> undef,
        "path4"		=> undef,
        "pkey"		=> undef,
        );
my %hashVarUpdBuf = ();
my %hashVarRegexs = (
    	"AADEFAULT" => qr/(.*)/,
        "alternate" => qr/^([\d]+|[ ]+)$/,
        "desc"    => qr/^([\w\-' ]{2,30})$/,
#       "dialplan" =>  qr/^([\dNXZ!\[\]\/\._-\s]+)$/,
        "dialplan" =>  qr/^([\w\.\[\]\+\*\/!_-\s]{3,})$/,       
        "route"    => qr/^(\w{2,30})$/,
        );
my %hashColorDefaults = %hashVarDefaults;
while ( my $tk = each %hashColorDefaults ) {
        $hashColorDefaults{$tk} = 'black';
}

my $buttoncolour = 'lightskyblue';
my $maxundonum = '5';
my $pages = 1 ;
my $page = 1;
my $epages = 1;
my $epage = 1;

#
#
#

my $q = new CGI;
my %params = $q->Vars;


if ($q->param ('save.x'))
{
	performUpdate ($q);
}


elsif ($q->param ('new.x') )
{
	performCreate ($q);
}

elsif ($q->param ('newsave.x') )
{
	performCreateLinesIn ($q);
}

elsif ($q->param ('cancel.x') )
{
    showInitial ($q, '');
}

elsif ($q->param ('initcommit.x') )
{
        commit ($q);
}

elsif ($q->param ('newcommit.x') )
{
        performCreateLinesIn ($q);
}

elsif ($q->param ('commit.x') )
{
    performUpdate ($q);
}

elsif ($q->param ('delete.x') )
{
    performDelete ($q);
}

#elsif ($q->param ('undo.x'))
#{
#    SarkSubs::SQLiteUndo();
#    $q->delete_all();
#    showInitial ($q,"Undo Processing complete");
#}

elsif (! grep (/^state$/, $q->param))
{
    showInitial ($q, '');
}

#Lines IN
elsif ($q->param ('state') eq "linesIn")
{
    linesIn ($q);
}

#other


else
{
    die "STATE ERROR!! ";
}

exit (0);

#------------------------------------------------------------
# subroutine to display initial form
#------------------------------------------------------------

sub showInitial ($$)
{
    my ($q, $msg) = @_;
    my $dbh = SarkSubs::SQLiteConnect();
    my $commit = SarkSubs::SQLiteGet($dbh, "SELECT MYCOMMIT FROM globals where pkey = 'global'");
    my @Routes = sort (SarkSubs::SQLiteGetKeys($dbh, "SELECT pkey FROM Route" ));
    SarkSubs::sark_header ($q);

    print h1( SarkSubs::tt_display('Sarksystemh11').($msg || 'Routes') );
    print '<hr class="hr" />';

    print '<div class="buttons">';
    SarkSubs::sark_button_new();
    SarkSubs::sark_button_commit("initcommit", $commit);
 #   if (SarkSubs::SQLiteCheckUndo) {
 #       SarkSubs::sark_button_undo();
 #   }
    print '</div>';

    print "<div class=etabs>";
    unless (@Routes) {
        print '<span style="color:red;font-weight:bold">'.'There are no Routes on the system.'.'</span>';
        print '</div>';
        SarkSubs::sark_footer($q);
        SarkSubs::SQLiteDisconnect($dbh);
        exit(0);
    }

    print $q->table({border => 1, cellspacing => 1, cellpadding => 4});

    print $q->Tr (
        	      $q->th({class=>"srk-border"}, SarkSubs::aHeaderFor('route')),
                      $q->th({class=>"srk-border"}, SarkSubs::aHeaderFor('cluster')),
                      $q->th({class=>"srk-border"}, SarkSubs::aHeaderFor('routedesc')),
                      $q->th({class=>"srk-border"}, SarkSubs::aHeaderFor('dialplan')),
                      $q->th({class=>"srk-border"}, SarkSubs::aHeaderFor('path1')),
#                      $q->th({class=>"srk-border"}, SarkSubs::aHeaderFor('path2')),
#                      $q->th({class=>"srk-border"}, SarkSubs::aHeaderFor('auth')),
                      $q->th({class=>"srk-border"}, SarkSubs::aHeaderFor('active')),
                      $q->th({class=>"srk-border"}, ''),
                      $q->th({class=>"srk-border"}, '')
                      );
    my $rowcolor = 0x01;
#        my $i = $linelow;;
#        while ($i<$linehigh && $i <= $#Routes) {
#        	my $pkey = @Routes[$i];
		foreach(@Routes) {
			my $pkey = $_;
        	%Route = SarkSubs::SQLiteGetHash($dbh, "SELECT * FROM Route WHERE pkey = '$pkey'");

	    if ( length $Route{cluster} > 10 ) {
			$Route{cluster} = substr($Route{cluster} , 0, 7);
			$Route{cluster} .= '...';
       	}
		if ( length $Route{desc} > 15 ) {
			$Route{desc} = substr($Route{desc} , 0, 12);
			$Route{desc} .= '...';
       	}

		if ( length $Route{dialplan} > 30 ) {
			$Route{dialplan} = substr($Route{dialplan} , 0, 27);
			$Route{dialplan} .= '...';
       	}

            	print $q->Tr ({-class => "d".$rowcolor},
            		  $q->td({class=>"srk-border"}, $pkey),
                          $q->td({class=>"srk-border"}, $Route{cluster}),
                          $q->td({class=>"srk-border"}, $Route{desc}),
                          $q->td({class=>"srk-border"}, $Route{dialplan}),
                          $q->td({class=>"srk-border"}, $Route{path1}),
#                          $q->td({class=>"srk-border"}, $Route{path2}),
#                          $q->td({class=>"srk-border"}, $Route{auth}),
		          $q->td({class=>"srk-border"}, $Route{active}),
                    	  $q->td({class=>"srk-border"},
                    	  	$q->a ({href => $q->url (-absolute => 1)
                        	. "?state=linesIn&change=yes&pkey=$pkey"},
				$editicon)),
                    	  $q->td({class=>"srk-border"},
                        	$q->a ({href => $q->url (-absolute => 1)
                        	. "?state=linesIn&delete=yes&pkey=$pkey"},
			   	$trashicon)));
            	$rowcolor = $rowcolor ^ 1;
 #               $i++;
    }
    print '</table>';

#    SarkSubs::printpages($pages, $page);

    print '</div>';
    SarkSubs::sark_footer($q);
    SarkSubs::SQLiteDisconnect($dbh);
}

sub commit ($)
{
    SarkSubs::sysCommit($q);
    showInitial ($q, "<font color = red>@{[SarkSubs::tt_display('Sarksystemmsg1')]}</font color = red><font color = black>");
}

sub linesIn ($)
{
    my ($q) = @_;
    my $pkey  		= $q->param ('pkey');
    my $delete   	= $q->param ('delete');
    my $change   	= $q->param ('change');
    if ($delete eq 'yes') {
        performDelete($q);
    	return 0;
    }

    my $dbh = SarkSubs::SQLiteConnect();
    my @Clusters = sort (SarkSubs::SQLiteGetKeys($dbh, "SELECT pkey FROM Cluster"));
    my @Trunks = sort (SarkSubs::SQLiteGetKeys($dbh, "SELECT lineIO.pkey FROM lineIO, Carrier "
    				."WHERE lineIO.carrier=Carrier.pkey "
                                ."AND NOT (carriertype='DiD' or carriertype='CLID' or carriertype='Class')"));
    %Route = SarkSubs::SQLiteGetHash($dbh, "SELECT * FROM Route WHERE pkey = '$pkey'");
    my @groupnum = ();
    my $numexists = 0;

    SarkSubs::sark_header ($q);
    print h1( SarkSubs::tt_display('Sarksystemh11')."Route $pkey" );
    print '<hr class="hr" />';
    if (@Verrors) {
	SarkSubs::sark_error(\@Verrors);
    }
    print '<div class="buttons">';
    SarkSubs::sark_button_cancel();
    SarkSubs::sark_button_save("save");
    SarkSubs::sark_button_commit( "commit", SarkSubs::SQLiteGet($dbh, "SELECT MYCOMMIT FROM globals where pkey = 'global'") );
    print '</div>';


    print "<div>";
#    print "<div class=\"notes\">
#        <h4>Route Details</h4>
#        <p class=\"last\">These are the details for the Route you selected. You may freely modify the unprotected variables...";
#    print '</p></div>';


        print SarkSubs::aLabelFor('active');
        print $q->popup_menu (
                        -name    => 'active',
                        -values  => ['YES','NO'],
                        -default => $Route{active});
        print SarkSubs::aLabelFor('path1');
        print $q->popup_menu (
                        -name    => 'path1',
                        -values  => ['None', @Trunks],
                        -default => $Route{path1});
        print SarkSubs::aLabelFor('path2');
        print $q->popup_menu (
                        -name    => 'path2',
                        -values  => ['None', @Trunks],
                        -default => $Route{path2});
        print SarkSubs::aLabelFor('path3');
        print $q->popup_menu (
                        -name    => 'path3',
                        -values  => ['None', @Trunks],
                        -default => $Route{path3});
        print SarkSubs::aLabelFor('path4');
        print $q->popup_menu (
                        -name    => 'path4',
                        -values  => ['None', @Trunks],
                        -default => $Route{path4});
        print SarkSubs::aLabelFor('dialplan');
        print $q->textfield (
                        -name     => 'dialplan',
#                        -override => 1,
                        -default  => $Route{dialplan},
                        -style	  => "Color: $hashColorDefaults{dialplan}",
                        -size     => 50);
        print SarkSubs::aLabelFor('alternate');
        print $q->textfield (
                        -name     => 'alternate',
                        -override => 1,
                        -style    => "color: $hashColorDefaults{alternate}",
                        -default  => $Route{alternate},
                        -size     => 30);
        print SarkSubs::aLabelFor('auth');
        print $q->popup_menu (
                        -name    => 'auth',
                        -values  => ['NO', 'YES'],
                        -default => $Route{auth});
        print SarkSubs::aLabelFor('description');
        print $q->textfield (
                        -name     => 'desc',
                        -override => 1,
                        -style    => "color: $hashColorDefaults{desc}",
                        -default  => $Route{desc},
                        -size     => 30);
        print SarkSubs::aLabelFor('cluster');
        print $q->popup_menu (
                        -name    => 'cluster',
                        -values  => [@Clusters],
                        -default => $Route{cluster});


print '</div>';
#        SarkSubs::sark_button_save("save");
#        SarkSubs::sark_button_cancel();
#        SarkSubs::sark_button_commit( "commit", SarkSubs::SQLiteGet($dbh, "SELECT MYCOMMIT FROM globals where pkey = 'global'") );

    print $q->hidden (-name => 'pkey',  -override => 1, -default => $pkey);

    SarkSubs::sark_footer($q);
    SarkSubs::SQLiteDisconnect($dbh);
}

sub performUpdate ($)
{
	my ($q) = shift;
        my $response;
        my %hashScrnVars = $q->Vars ;
        my $dbh = SarkSubs::SQLiteConnect();
        %Route = SarkSubs::SQLiteGetHash($dbh, "SELECT * FROM Route WHERE pkey = '$hashScrnVars{pkey}'");
        $gonogo = SarkSubs::validateTuple(\%hashScrnVars, \%Route, \%hashVarRegexs,
    			\%hashVarUpdBuf, \%hashColorDefaults,
                        \@Verrors);
        unless ( $gonogo ) {
    		SarkSubs::updateTuple (\%hashVarUpdBuf, \%Route, "Route", $dbh);
    	}
        SarkSubs::SQLiteDisconnect($dbh);
    	if ( $gonogo ) {
    		linesIn($q);
        	return 0;
    	}
    	if ($q->param('commit.x')) {
        	SarkSubs::sysCommit($q);
                $response = "Committed!";
    	}
    	showInitial ($q,$response);
    	return 0;
}
sub performCreate ($)
{
    my ($q) = shift;
    my $dbh = SarkSubs::SQLiteConnect();
    my $commit = SarkSubs::SQLiteGet($dbh, "SELECT MYCOMMIT FROM globals where pkey = 'global'");
    my @Clusters = sort (SarkSubs::SQLiteGetKeys($dbh, "SELECT pkey FROM Cluster"));
    my @Trunks = sort (SarkSubs::SQLiteGetKeys($dbh, "SELECT lineIO.pkey FROM lineIO, Carrier "
    							."WHERE lineIO.carrier=Carrier.pkey "
                                                        ."AND NOT (carriertype='DiD' or carriertype='CLID' or carriertype='Class')"));

    SarkSubs::SQLiteDisconnect($dbh);
    SarkSubs::sark_header ($q);
    print h1( SarkSubs::tt_display('Sarksystemh11')."Route Create" );
    print '<hr class="hr" />';
    if (@Verrors) {
	SarkSubs::sark_error(\@Verrors);
    }
    print '<div class="buttons">';
    SarkSubs::sark_button_cancel();
    SarkSubs::sark_button_save("newsave");
    SarkSubs::sark_button_commit("newcommit",$commit);
    print '</div>';


    print '<div>';
#    print '<div class="notes">';
#    print '<h4>Route Details</h4>';
#    print '<p class="last">fill out the details for your Route.../>';
#    print '</div>';


#    print '<br><br>';
        print SarkSubs::aLabelFor('route');
    	print $q->textfield (
                        -name     => 'pkey',
                        -size     => 10);
 	print SarkSubs::aLabelFor('active');
    	print $q->popup_menu (
                        -name    => 'active',
                        -values  => ['YES','NO']);

 	print SarkSubs::aLabelFor('path1');
    	print $q->popup_menu (
                        -name    => 'path1',
                        -values  => ['None', @Trunks]);

 	print SarkSubs::aLabelFor('path2');
    	print $q->popup_menu (
                        -name    => 'path2',
                        -values  => ['None', @Trunks]);
 	print SarkSubs::aLabelFor('path3');
    	print $q->popup_menu (
                        -name    => 'path3',
                        -values  => ['None', @Trunks]);
 	print SarkSubs::aLabelFor('path4');
    	print $q->popup_menu (
                        -name    => 'path4',
                        -values  => ['None', @Trunks]);
 	print SarkSubs::aLabelFor('auth');
    	print $q->popup_menu (
                        -name    => 'auth',
                        -values  => ['NO', 'YES']);
 	print SarkSubs::aLabelFor('dialplan');
    	print $q->textfield (
                        -name     => 'dialplan',
                        -override => 1,
                        -style    => "color: $hashColorDefaults{dialplan}",
                        -default  => $hashScrnVars{dialplan},
                        -size     => 30);
 	print SarkSubs::aLabelFor('alternate');
    	print $q->textfield (
                        -name     => 'alternate',
                        -override => 1,
                        -style    => "color: $hashColorDefaults{alternate}",
                        -default  => $hashScrnVars{alternate},
                        -size     => 15);
 	print SarkSubs::aLabelFor('description');
    	print $q->textfield (
                        -name     => 'desc',
                        -override => 1,
                        -style    => "color: $hashColorDefaults{desc}",
                        -default  => $hashScrnVars{desc},
                        -size     => 30);
 	print SarkSubs::aLabelFor('cluster');
    	print $q->popup_menu (
                        -name    => 'cluster',
                        -values  => [@Clusters],
                        -default => 'default');

        print $q->br;



    print '</div>';
#    print $q->hidden (-name => 'pkey',  -override => 1, -default => $route);

    SarkSubs::sark_footer($q);

}

sub performCreateLinesIn ($)
{
	my ($q) = shift;
        %hashScrnVars = $q->Vars;
        my $dbh = SarkSubs::SQLiteConnect();
        my %hashRecordColumns = SarkSubs::SQLiteGetHashCols($dbh, 'Route');
        SarkSubs::SQLiteDisconnect($dbh);
        $gonogo = SarkSubs::validateTuple(\%hashScrnVars, \%hashRecordColumns, \%hashVarRegexs,
    			\%hashVarOutBuf, \%hashColorDefaults,
                        \@Verrors);
	unless ($gonogo) {
#
#		Set defaults
#
        	while ( my ($key, $value) = each %hashVarDefaults ) {
                	unless ( $hashVarOutBuf{$key} ) {
                        	if ($hashVarDefaults{$key}) {
                        		$hashVarOutBuf{$key} = $hashVarDefaults{$key};
                                }
                        }
                }
#
#		Create record
#
        	my $dbh = SarkSubs::SQLiteConnect();
        	SarkSubs::newTuple( \%hashVarOutBuf, "Route", $dbh);
                SarkSubs::SQLiteDisconnect($dbh);
       		if ( $hashScrnVars{'newcommit.x'} ) {
    			SarkSubs::sysCommit($q);
    		}
                showInitial ($q,"Entry Created!");
    	}
        else {
        	performCreate ($q);
        }
        return 0;
}

sub performDelete ($)
{
    my ($q) = shift;
    my $pkey = $q->param ('pkey');
    my $dbh = SarkSubs::SQLiteConnect();
    SarkSubs::SQLiteDo($dbh, "UPDATE globals SET MYCOMMIT='YES' WHERE pkey='global'");
    SarkSubs::SQLiteDelete($dbh,"DELETE FROM Route where pkey='$pkey'");
#    SarkSubs::SQLiteCommit($dbh);
    SarkSubs::SQLiteDisconnect($dbh);
    showInitial ($q, "<font color = red>Successfully deleted Trunk $pkey</font color = red><font color = black>");
}
