#!/usr/bin/perl

#----------------------------------------------------------------------
# heading     : Telephony
# description : Call Groups
# navigation  : 4000 4813
#
# Copyright (c) selintra.com         2005
#
#----------------------------------------------------------------------
#----------------------------------------------------------------------
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
#
# Technical support for this program is available from Selintra Ltd
# Please visit our web site www.selintra.com/ for details.
#----------------------------------------------------------------------

use lib '/opt/sark/perl/modules';

use strict;
use CGI ':all';
use CGI::Carp qw(fatalsToBrowser);
use sark::SarkSubs;
sub showInitial ($$);
sub commit ($);
sub createSpeed ($);
sub performCreateSpeed ($);
sub performDelete ($);


BEGIN
{
    # Clear PATH and related environment variables so that calls to
    # external programs do not cause results to be tainted. See
    # "perlsec" manual page for details.

    $ENV {'PATH'} = '';
    $ENV {'SHELL'} = '/bin/bash';
    delete $ENV {'ENV'};
}

#esmith::util::setRealToEffective ();
$< = $>;
$( = $);

$CGI::POST_MAX=1024 * 100;  # max 100K posts
$CGI::DISABLE_UPLOADS = 1;  # no uploads

my $editicon = "<img src=\"/sark-common/edit.png\" border=0 title = \"@{[SarkSubs::tt_display('Sarkedittext')]}\">";
my $yesicon = "<img src=\"/sark-common/connected.png\" border=0 title = \"@{[SarkSubs::tt_display('Sarktinfotext')]}\">";
my $noicon = "<img src=\"/sark-common/actions/no.png\" border=0 title = \"@{[SarkSubs::tt_display('Sarkoffline')]}\" >";
my $warnicon = "<img src=\"/sark-common/warning.png\" border=0 title = \"@{[SarkSubs::tt_display('Sarkwarntext')]}\" >";
my $infoicon = "<img src=\"/sark-common/info.png\" border=0 >";
my $greenicon = "<img src=\"/sark-common/actions/apply.png\" border=0 title = \"@{[SarkSubs::tt_display('Sarkremotetext')]}\" >";
my $activeicon = "<img src=\"/sark-common/actions/apply.png\" border=0 title = \"@{[SarkSubs::tt_display('Sarkactivetext')]}\" >";
my $monicon = "<img src=\"/sark-common/actions/apply.png\" border=0 title = \"@{[SarkSubs::tt_display('Sarkmontext')]}\" >";
my $trashicon = "<img src=\"/sark-common/edittrash.png\" border=0 onclick=\"return confirmOK('Delete this Object - Confirm?')\" title = \"@{[SarkSubs::tt_display('Sarkdeletetext')]}\" >";

my %speed;
my %hashScrnVars;
my @Verrors;
my $gonogo = 0;
my $cfwd;
my %hashVarDefaults  = (
	"callerid" 		=> undef,
        "calleridname"		=> undef,
        "cluster"		=> "default",
        "desc"			=> undef,
        "devicerec"		=> undef,
        "greeting"		=> undef,
        "grouptype"		=> undef,
        "longdesc"		=> undef,
#        "num"			=> undef,
        "obeydnd"		=> undef,
        "out"			=> undef,
        "outcome"      		=> undef,
        "outcomerouteclass"    	=> 100,
        "pagegroup"		=> undef,
        "pkey"			=> undef,
        "ringdelay"    		=> "15",
        "speedalert"		=> undef,
	);
my %hashVarErrors;
my %hashVarOutBuf = (
	"callerid" 		=> undef,
        "calleridname"		=> undef,
        "cluster"		=> "default",
        "desc"	       		=> undef,
        "devicerec"		=> undef,
        "greeting"		=> undef,
        "grouptype"		=> undef,
        "longdesc"		=> undef,
#        "num"			=> undef,
        "obeydnd"		=> undef,
        "out"			=> undef,
        "outcomerouteclass"    	=> undef,
        "pagegroup"		=> undef,
        "pkey"			=> undef,
        "ringdelay"    		=> undef,
        "speedalert"		=> undef,
        );
my %hashVarUpdBuf = ();
my %hashVarRegexs = (
    	"AADEFAULT" => qr/(.*)/,
        "callerid" => qr/^(\d{2,18})$/,
        "calleridname" => qr/^([\w\-' ]{2,30})$/,
        "desc" => qr/^([\w\-' ]{2,30})$/,
        "pkey" => qr/^(\w{2,18})$/,
        "ringdelay" => qr/^(\d{1,3})$/,
#        "speedalert" => qr/^([\w\/-\\;:<>=]{5,40})$/,
        );

my %hashColorDefaults = %hashVarDefaults;
while ( my $tk = each %hashColorDefaults ) {
        $hashColorDefaults{$tk} = 'black';
}
my $pages = 1 ;
my $page = 1;
my $epages = 1;
my $epage = 1;

#
#
#

my $q = new CGI;

my %params = $q->Vars;
#
#  Retrieve the page number
#
for my $key ( keys %params ) {
       if ( $key =~ /^page(\d{1,}).x$/ ) {
       	  $page=$1;
          showInitial ($q, '');
          exit(0);
       }
       if ( $key =~ /^epage(\d{1,}).x$/ ) {
       	  $epage=$1;
          linesIn ($q);
          exit(0);
       }
}
if ($q->param ('new.x') )  {
	createSpeed ($q);
}
elsif ($q->param ('initcommit.x') ) {
        commit ($q);
}
elsif ($q->param ('commit.x') ) {
    performLinesIn ($q);
}
elsif ($q->param ('save.x') ) {
    performLinesIn ($q);
}
elsif ($q->param ('newcommit.x') ) {
    performCreateSpeed ($q);
}
elsif ($q->param ('newsave.x') ) {
    performCreateSpeed ($q);
}
elsif ($q->param ('delete.x') ) {
    performDelete ($q);
}
elsif ($q->param ('undo.x'))
{
    SarkSubs::SQLiteUndo();
    $q->delete_all();
    showInitial ($q,"Undo Processing complete");
}
elsif (! grep (/^state$/, $q->param)) {
    showInitial ($q, '');
}
elsif ($q->param ('cancel.x') ) {
    showInitial ($q, '');
}
elsif ($q->param ('state') eq "linesIn") {
    linesIn ($q);
}
else {
    die "STATE ERROR!! ";
}
exit (0);

#------------------------------------------------------------
# subroutine to display initial form
#------------------------------------------------------------

sub showInitial ($$)
{
    my ($q, $msg) = @_;
    my $dbh = SarkSubs::SQLiteConnect();
    my $commit = SarkSubs::SQLiteGet($dbh, "SELECT MYCOMMIT FROM globals where pkey = 'global'");
    my @speed = sort (SarkSubs::SQLiteGetKeys($dbh, "SELECT pkey FROM speed WHERE pkey != 'RINGALL'" ));
    SarkSubs::sark_header ($q);
    my $numlines = @speed;
    my $remainder = $numlines % 12;
    $pages = int($numlines / 12);
    if ($remainder) {
    	$pages++;
    }
    my $linelow = (($page-1) * 12);
    my $linehigh = $linelow + 12;
    print h1( SarkSubs::tt_display('Sarksystemh11').($msg || 'Callgroups') );
    print '<hr class="hr" />';

    print '<div class="buttons">';
    SarkSubs::sark_button_new();
    SarkSubs::sark_button_commit("initcommit", $commit);
#    if (SarkSubs::SQLiteCheckUndo) {
#        SarkSubs::sark_button_undo();
#    }
    print '</div>';


    print '<div>';

    print "<div class=etabs>";
    unless (@speed) {
        print '<span style="color:red;font-weight:bold">'.SarkSubs::tt_display('Sarkspeedmsg3').'</span>';
        print '</div>';
        SarkSubs::sark_footer($q);
        SarkSubs::SQLiteDisconnect($dbh);
        exit(0);
    }

#    	print "<p align=center>";
    print $q->table ({border => 1, cellspacing => 1, cellpadding => 4});

    print $q->Tr (
        	      $q->th({class=>"srk-border"}, SarkSubs::aHeaderFor('callgroup')),
                      $q->th({class=>"srk-border"}, SarkSubs::aHeaderFor('cluster')),
                      $q->th({class=>"srk-border"}, SarkSubs::aHeaderFor('description')),
                      $q->th({class=>"srk-border"}, SarkSubs::aHeaderFor('grouptype')),
                      $q->th({class=>"srk-border"}, SarkSubs::aHeaderFor('groupstring')),
                      $q->th({class=>"srk-border"}, SarkSubs::aHeaderFor('outcome')),
                      
                      $q->th({class=>"srk-border"}, SarkSubs::aHeaderFor('devicerec')),
                      $q->th({class=>"srk-border"}, ''),
                      $q->th({class=>"srk-border"}, '')
                      );

        my $rowcolor = 0x01;
#        my $i = $linelow;;
#        while ($i<$linehigh && $i <= $#speed) {
		foreach (@speed) {
#        	my $pkey = @speed[$i];
        	my $pkey = $_;
        	%speed = SarkSubs::SQLiteGetHash($dbh, "SELECT * FROM speed WHERE pkey = '$pkey'");
		if ( length $speed{out} > 30 ) {
			$speed{out} = substr($speed{out} , 0, 27);
			$speed{out} .= '...';
       	}
		if ( length $speed{longdesc} > 15 ) {
			$speed{longdesc} = substr($speed{longdesc} , 0, 14);
			$speed{longdesc} .= '.';
       	}

            	print $q->Tr ({-class => "d".$rowcolor},
            	      $q->td({class=>"srk-border"}, $pkey),
                      $q->td({class=>"srk-border"}, $speed{cluster}),
                      $q->td({class=>"srk-border"}, $speed{longdesc}),
                      $q->td({class=>"srk-border"}, $speed{grouptype}),
                      $q->td({class=>"srk-border"}, $speed{out}),
                      $q->td({class=>"srk-border"}, $speed{outcome}),
                      
                      $q->td({class=>"srk-border"}, $speed{devicerec}),
                      $q->td({class=>"srk-border"},
                        	$q->a ({href => $q->url (-absolute => 1)
                        	. "?state=linesIn&change=yes&pkey=$pkey"},
				$editicon)),
                      $q->td({class=>"srk-border"},
                        	$q->a ({href => $q->url (-absolute => 1)
                        	. "?state=linesIn&delete=yes&pkey=$pkey"},
			   	$trashicon)));

            $rowcolor = $rowcolor ^ 1;
#            $i++;
        }
    print '</table>';
#    SarkSubs::printpages($pages, $page);
    print '</div>';
    print '</div>';
    SarkSubs::sark_footer($q);
    SarkSubs::SQLiteDisconnect($dbh);
}

sub commit ($)
{
    SarkSubs::sysCommit($q);
    showInitial ($q, "Commit Complete!");
}

sub createSpeed ($)
{
    my ($q) = shift;
    my $dbh = SarkSubs::SQLiteConnect();

    my @Queues = sort (SarkSubs::SQLiteGetKeys($dbh, "SELECT pkey FROM Queue" ));
    my @Extensions = sort (SarkSubs::SQLiteGetKeys($dbh, "SELECT pkey FROM IPphone" ));
    my @Clusters = sort (SarkSubs::SQLiteGetKeys($dbh, "SELECT pkey FROM Cluster"));
    my @IVRs = sort (SarkSubs::SQLiteGetKeys($dbh, "SELECT pkey FROM ivrmenu" ));
    my @CustomApps = sort (SarkSubs::SQLiteGetKeys($dbh, "SELECT pkey FROM Appl" ));
    my @SpeedDials = sort (SarkSubs::SQLiteGetKeys($dbh, "SELECT pkey FROM speed" ));
    my @Carriers = sort (SarkSubs::SQLiteGetKeys($dbh, "SELECT pkey FROM Carrier" ));
    my @Trunks = sort (SarkSubs::SQLiteGetKeys($dbh, "SELECT pkey FROM lineIO" ));
    my @Vmails;
    foreach (@Extensions) {
    	push (@Vmails,"*".$_)
    }
    push(@IVRs, "Default IVR");

    SarkSubs::sark_header ($q);
    print h1( SarkSubs::tt_display('Sarksystemh11')."New Callgroup" );
    print '<hr class="hr" />';
    if (@Verrors) {
	SarkSubs::sark_error(\@Verrors);
    }

    print '<div class="buttons">';
    SarkSubs::sark_button_cancel();
    SarkSubs::sark_button_save("newsave");
    SarkSubs::sark_button_commit( "newcommit", SarkSubs::SQLiteGet($dbh, "SELECT MYCOMMIT FROM globals where pkey = 'global'") );
    print '</div>';

    print '<div>';
#    print "<div class=\"notes\">
#        <h4>Extension Details</h4>
#        <p class=\"last\">Fill out the details for the new Call Group...</p>
#       </div>";
    print SarkSubs::aLabelFor('callgroup');
    print $q->textfield (
                        -name     => 'pkey',
                        -override => 1,
                        -style    => "color: $hashColorDefaults{pkey}",
                        -default  => $hashScrnVars{pkey},
                        -size     => 8);

    print SarkSubs::aLabelFor('grouptype');
    print $q->popup_menu (
                        -name    => 'grouptype',
						-values  => ['Ring','Hunt','Page','Alias']);
    print SarkSubs::aLabelFor('cluster');
    print $q->popup_menu (
                        -name     => 'cluster',
						-values	  => [@Clusters],
						-default  => 'default');
    print SarkSubs::aLabelFor('devicerec');
    print $q->popup_menu (
                        -name    => 'devicerec',
                  	-values  => [SarkSubs::get_rec_list, "Inbound"]);
    print SarkSubs::aLabelFor('ringdelay');
    print $q->textfield (
                        -name     => 'ringdelay',
                        -override => 1,
                        -style    => "color: $hashColorDefaults{ringdelay}",
                        -default  => $hashScrnVars{ringdelay},
                        -size     => 2);               
    print SarkSubs::aLabelFor('tag');
    print $q->textfield (
                        -name     => 'calleridname',
                        -override => 1,
                        -style    => "color: $hashColorDefaults{calleridname}",
                        -default  => $hashScrnVars{calleridname},
                        -size     => 20);
    print SarkSubs::aLabelFor('groupstring');
    print $q->textfield (
                        -name     => 'out',
                        -override => 1,
                        -style    => "color: $hashColorDefaults{out}",
                        -default  => $hashScrnVars{out},
                        -size     => 30);
    print SarkSubs::aLabelFor('alertinfo');
    print $q->textfield (
                        -name     => 'speedalert',
                        -override => 1,
                        -style    => "color: $hashColorDefaults{speedalert}",
                        -default  => $hashScrnVars{speedalert},
                        -size     => 30);

    print SarkSubs::aLabelFor('description');
    print $q->textfield (
                        -name     => 'longdesc',
                        -override => 1,
                        -style    => "color: $hashColorDefaults{longdesc}",
                        -default  => $hashScrnVars{longdesc},
                        -size     => 30);
    print SarkSubs::aLabelFor('outcome');
    print $q->popup_menu (
                        -name    => 'outcome',
                        -values  => ["Operator", "Hangup",
                               optgroup (-name => "IVRs",
                                         -values => [@IVRs]),
                               optgroup (-name => "QUEUES",
                                         -values => [@Queues]),
                               optgroup (-name => "EXTENSIONS",
                                         -values => [@Extensions]),
                               optgroup (-name => "CALL GROUPS",
                                         -values => [@SpeedDials]),
                               optgroup (-name => "GET VOICEMAIL",
                                         -values => ['Retrieve Voicemail']),
                               optgroup (-name => "LEAVE VOICEMAIL",
                                         -values => [@Vmails]),
                               optgroup (-name => "Custom Apps",
                                         -values => [@CustomApps])]);

    print '</div>';

    SarkSubs::sark_footer($q);
    SarkSubs::SQLiteDisconnect($dbh);
}


sub performCreateSpeed ($)
{
    my ($q)     = shift;
    %hashScrnVars = $q->Vars ;
    my $response;
    my $loop = 0;
    #   call subs to set the routeclass
    $hashScrnVars{outcomerouteclass} = SarkSubs::routeClass($hashScrnVars{outcome});
    my $dbh = SarkSubs::SQLiteConnect();
    # check for loops
    push(my @speed, $hashScrnVars{pkey});

    my @outs = split / /, $hashScrnVars{out};
    foreach (@outs) {
        if ( $_ eq $hashScrnVars{pkey} ) {
                $loop = 1;
                    push (@Verrors, "Loop Detected in the call list!");
                    $gonogo = 1;
                    last;
        }
    	elsif ( SarkSubs::SQLiteGet($dbh, "SELECT pkey FROM speed where pkey = '$_'" ) ) {
	    my $speednum = $_;
	    foreach (@speed) {
		if ($_ eq $speednum) {
		    $loop = 1;
                    push (@Verrors, "Loop Detected in the call list!");
                    $gonogo = 1;
                    last;
		}
	    }
	    unless ($loop) {
		push(@speed, $speednum);
		my $tmp = SarkSubs::SQLiteGet($dbh, "SELECT out FROM speed where pkey = '$speednum'") ;
		my @tmps = split / /, $tmp;
		foreach (@tmps) {
		    push(@outs, $_);
		}
	    }
	}
    }
    unless ($gonogo) {

        my %hashRecordColumns = SarkSubs::SQLiteGetHashCols($dbh, 'speed');
        $gonogo = SarkSubs::validateTuple(\%hashScrnVars, \%hashRecordColumns, \%hashVarRegexs,
    			\%hashVarOutBuf, \%hashColorDefaults,
                        \@Verrors);
    	unless ( $gonogo ) {
#
#		Set defaults
#
        	while ( my ($key, $value) = each %hashVarDefaults ) {
                	unless ( $hashVarOutBuf{$key} ) {
                        	if ($hashVarDefaults{$key}) {
                        		$hashVarOutBuf{$key} = $hashVarDefaults{$key};
                                }
                        }
                }
#
#		Create record
#
    		SarkSubs::newTuple( \%hashVarOutBuf, "speed", $dbh);
        }
    }
    SarkSubs::SQLiteDisconnect($dbh);
    if ( $gonogo ) {
    	createSpeed ($q);
       	return 0;
    }
    if ($q->param('commit.x')) {
       	SarkSubs::sysCommit($q);
               $response = "Committed!";
    }
    showInitial ($q,$response);
    return 0;

}
sub linesIn ($)
{
    my ($q) = shift;
    my $pkey    = $q->param ('pkey' || '');
    my $delete  = $q->param ('delete');
    if ($delete eq 'yes') {
        performDelete($q);
    	return 0;
    }
    my $dbh = SarkSubs::SQLiteConnect();


    %speed = SarkSubs::SQLiteGetHash($dbh, "SELECT * FROM speed WHERE pkey = '$pkey'");

    my @Queues = sort (SarkSubs::SQLiteGetKeys($dbh, "SELECT pkey FROM Queue" ));
    my @Extensions = sort (SarkSubs::SQLiteGetKeys($dbh, "SELECT pkey FROM IPphone" ));
    my @Clusters = sort (SarkSubs::SQLiteGetKeys($dbh, "SELECT pkey FROM Cluster"));
    my @IVRs = sort (SarkSubs::SQLiteGetKeys($dbh, "SELECT pkey FROM ivrmenu" ));
    my @CustomApps = sort (SarkSubs::SQLiteGetKeys($dbh, "SELECT pkey FROM Appl" ));
    my @SpeedDials = sort (SarkSubs::SQLiteGetKeys($dbh, "SELECT pkey FROM speed" ));
    my @Carriers = sort (SarkSubs::SQLiteGetKeys($dbh, "SELECT pkey FROM Carrier" ));
    my @Trunks = sort (SarkSubs::SQLiteGetKeys($dbh, "SELECT pkey FROM lineIO" ));
    my @Vmails;
    foreach (@Extensions) {
    	push (@Vmails,"*".$_)
    }
    push(@IVRs, "Default IVR");
    my $xref;
    my $tref;
    foreach (@Trunks) {
       	my %rec = SarkSubs::SQLiteGetHash($dbh, "SELECT * FROM lineIO WHERE pkey = '$_'");
       	if ( $rec{openroute} eq $pkey || $rec{closeroute} eq $pkey ) {
               	$tref .= "Trunk $_ references this Callgroup<br>";
       	}
    }
    if ($tref) {
    	$xref .= $tref;
       	$tref = "";
    }
    else {
    	$xref .= "No Trunks reference this Callgroup<br/>";
    }
    foreach (@SpeedDials) {
       	my %rec = SarkSubs::SQLiteGetHash($dbh, "SELECT * FROM speed WHERE pkey = '$_'");
       	if ( $rec{out} =~ $pkey || $rec{outcome} =~ $pkey ) {
               	/^(\d{1,4})/;
               	$tref .= "Callgroup $1 references this Callgroup<br>";
       	}
    }
    if ($tref) {
    	$xref .= $tref;
       	$tref = "";
    }
    else {
    	$xref .= "No Callgroups reference this Callgroup<br/>";
    }
    foreach (@IVRs) {
       	my %rec = SarkSubs::SQLiteGetHash($dbh, "SELECT * FROM ivrmenu WHERE pkey = '$_'");
       	if ($rec{timeout} eq $pkey ) {
               	$tref .= "IVR Timeout $_ refrences this Callgroup<br>";
       	}
       	else {
               	for ( my $i=0; $i <= 11; $i++ ) {
                       	if  ($rec{"option".$i} eq $pkey) {
                               	$tref .=  "IVR $_ references this Callgroup<br>";
                               	last;
                       	}
               	}
       	}
    }
    if ($tref) {
    	$xref .= $tref;
       	$tref = "";
    }
    else {
    	$xref .= "No IVRs reference this Callgroup<br/>";
    }
#}
#
# escape leading * - Perl CGI doesn't like them.
#
    if ($speed{outcome} =~ /^\*/) {
    	my $escape = '\\'.$speed{outcome};
        $speed{outcome} = $escape;
    }
    my $displayLongdesc = $speed{longdesc};
    if ( length $speed{longdesc} > 20 ) {
			$displayLongdesc = substr($speed{longdesc} , 0, 19);
			$displayLongdesc .= '.';
       	}
    
    SarkSubs::sark_header ($q);
    print h1( SarkSubs::tt_display('Sarksystemh11')."Callgroup $pkey ($displayLongdesc)" );
    print '<hr class="hr" />';
    if (@Verrors) {
	SarkSubs::sark_error(\@Verrors);
    }

    print '<div class="buttons">';
    SarkSubs::sark_button_cancel();
    SarkSubs::sark_button_save("save");
    SarkSubs::sark_button_commit( "commit", SarkSubs::SQLiteGet($dbh, "SELECT MYCOMMIT FROM globals where pkey = 'global'") );
    print '</div>';


    print '<div id="pagetabs" class="ui-tabs" >';
    print "\n";
    print '<ul>'."\n";
    print '<li><a href="#general">General</a></li>'."\n";
    print '<li><a href="#xref" >XREF</a></li>'."\n";
    print '</ul>'."\n";

#
#   TAB XREF table
#
    print '<div id="xref" class="ui-tabs-hide">';
    print "\n";

    print '<span style="color: rgb(0, 0, 0); font-weight:bold; font-size:small; ">Cross References to this CallGroup</span><br />';
    print $q->br;
    print "$xref";
    print $q->br;
    print '</div>';
#
#       TAB DIVEND
#
#
#   TAB general
#
    print '<div id="general" class="ui-tabs-hide">';
    print SarkSubs::aLabelFor('callgroup');
    print $q->textfield (
                        -name     => 'pkey',
                        -readonly =>'readonly',
                        -style    =>'background-color: lightgrey',
                        -override => 1,
                        -default  => $pkey,
                        -size     => 8);
    print SarkSubs::aLabelFor('grouptype');
    print $q->popup_menu (
                        -name    => 'grouptype',
                  	-values  => ['Ring','Hunt','Page','Alias'],
                  	-default => $speed{grouptype});
    print SarkSubs::aLabelFor('cluster');
    print $q->popup_menu (
                        -name     => 'cluster',
			-values	  => [@Clusters],
                        -default  => $speed{cluster});
    print SarkSubs::aLabelFor('devicerec');
    print $q->popup_menu (
                        -name    => 'devicerec',
                  	-values  => [SarkSubs::get_rec_list, "Inbound"],
                  	-default => $speed{devicerec});
    print SarkSubs::aLabelFor('ringdelay');
    print $q->textfield (
                        -name     => 'ringdelay',
                        -override => 1,
                        -style    => "color: $hashColorDefaults{ringdelay}",
                        -default  => $speed{ringdelay},
                        -size     => 2);
    print SarkSubs::aLabelFor('obeydnd');
    print $q->popup_menu (
                        -name     => 'obeydnd',
                        -values  => ['NO','YES']);                          
    print SarkSubs::aLabelFor('tag');
    print $q->textfield (
                        -name     => 'calleridname',
                        -override => 1,
                        -style    => "color: $hashColorDefaults{calleridname}",
                        -default  => $speed{calleridname},
                        -size     => 20);
    print SarkSubs::aLabelFor('groupstring');
    print $q->textfield (
                        -name     => 'out',
                        -override => 1,
                        -style    => "color: $hashColorDefaults{out}",
                        -default  => $speed{out},
                        -size     => 30);
    print SarkSubs::aLabelFor('alertinfo');
    print $q->textfield (
                        -name     => 'speedalert',
                        -override => 1,
                        -style    => "color: $hashColorDefaults{speedalert}",
                        -default  => $speed{speedalert},
                        -size     => 30);

    print SarkSubs::aLabelFor('description');
    print $q->textfield (
                        -name     => 'longdesc',
                        -override => 1,
                        -style    => "color: $hashColorDefaults{longdesc}",
                        -default  => $speed{longdesc},
                        -size     => 30);
    print SarkSubs::aLabelFor('outcome');
    print $q->popup_menu (
                        -name    => 'outcome',
                        -values  => ["Operator", "Hangup",
                               optgroup (-name => "IVRs",
                                         -values => [@IVRs]),
                               optgroup (-name => "QUEUES",
                                         -values => [@Queues]),
                               optgroup (-name => "EXTENSIONS",
                                         -values => [@Extensions]),
                               optgroup (-name => "CALL GROUPS",
                                         -values => [@SpeedDials]),
                               optgroup (-name => "GET VOICEMAIL",
                                         -values => ['Retrieve Voicemail']),
                               optgroup (-name => "LEAVE VOICEMAIL",
                                         -values => [@Vmails]),
                               optgroup (-name => "Custom Apps",
                                         -values => [@CustomApps])],
                  	-default => $speed{outcome});
    print '</div>';
#
#       TAB DIVEND
#

#
#  end of TABS DIV
#
    print "</div>";
#    print $q->hidden (-name => 'pkey',  -override => 1, -default => $pkey);
    SarkSubs::sark_footer($q);
    SarkSubs::SQLiteDisconnect($dbh);
}


sub performLinesIn ($)
{
    my ($q)     = shift;
    %hashScrnVars = $q->Vars ;
    my $response;

    my $loop = 0;
    #   call subs to set the routeclass
    $hashScrnVars{outcomerouteclass} = SarkSubs::routeClass($hashScrnVars{outcome});

    my $dbh = SarkSubs::SQLiteConnect();
    %speed = SarkSubs::SQLiteGetHash($dbh, "SELECT * FROM speed WHERE pkey = '$hashScrnVars{pkey}'");
    # check for loops
    push(my @speed, $hashScrnVars{pkey});
    my @outs = split / /, $speed{out};
    foreach (@outs) {
    	if (SarkSubs::SQLiteGet($dbh, "SELECT pkey FROM speed where pkey = '$_'")) {
	    my $speednum = $_;
	    foreach (@speed) {
		if ($_ eq $speednum) {
		    $loop = 1;
                    push (@Verrors, "Loop Detected in the call list!");
                    $hashScrnVars{out} = "";
                    $gonogo = 1;
		}
	    }
	    unless ($loop) {
		push(@speed, $speednum);
		my $tmp = SarkSubs::SQLiteGet($dbh, "SELECT out FROM speed where pkey = '$speednum'") ;
		my @tmps = split / /, $tmp;
		foreach (@tmps) {
		    push(@outs, $_);
		}
	    }
	}
    }
    unless ($gonogo) {
       	%speed = SarkSubs::SQLiteGetHash($dbh, "SELECT * FROM speed WHERE pkey = '$hashScrnVars{pkey}'");

        $gonogo = SarkSubs::validateTuple(\%hashScrnVars, \%speed, \%hashVarRegexs,
   			\%hashVarUpdBuf, \%hashColorDefaults,
                        \@Verrors);
        unless ( $gonogo ) {
  			SarkSubs::updateTuple (\%hashVarUpdBuf, \%speed, "speed", $dbh);
        }
    }
    SarkSubs::SQLiteDisconnect($dbh);
    if ( $gonogo ) {
    	linesIn ($q);
       	return 0;
    }
    if ($q->param('commit.x')) {
       	SarkSubs::sysCommit($q);
               $response = "Committed!";
    }
    showInitial ($q,$response);
    return 0;

}

sub performDelete ($)
{
    my ($q) = @_;
    my $pkey = $q->param ('pkey');

    my $dbh = SarkSubs::SQLiteConnect();
    #
    #  Remove trunk references
    #
    SarkSubs::SQLiteDo($dbh, "UPDATE lineIO SET openroute='Operator' WHERE openroute='pkey'" );
    SarkSubs::SQLiteDo($dbh, "UPDATE lineIO SET closeroute='Operator' WHERE closeroute='pkey'" );
    #
    #  Remove any references from other callgroups - to do this we can relationally
    #  change the outcome but we need to iterate over the call lists because
    #  they aren't normalised
    #
    SarkSubs::SQLiteDo($dbh, "UPDATE speed SET out='Operator' WHERE out='pkey'" );

    my @Callgroups = SarkSubs::SQLiteGetKeys($dbh, "SELECT pkey FROM speed" );
    foreach (@Callgroups) {
        my $out = SarkSubs::SQLiteGet($dbh, "SELECT out FROM speed where pkey = '$_'" );
        if ( $out =~ /$pkey/ ) {
#        	$out =~ s/^$pkey$//;
#        	$out =~ s/^$pkey //;
        	$out =~ s/$pkey//;
#        	$out =~ s/ $pkey$//;
		unless ($out) {
                	$out = "Operator";
                }
        	SarkSubs::SQLiteDo($dbh, "UPDATE speed SET out='$out' WHERE pkey='$_'" );
        }
    }
#
#	Iterate through the IVRs, hashing each one and matching on
#	the partial column name
#
    my @IVRs = SarkSubs::SQLiteGetKeys($dbh, "SELECT pkey FROM ivrmenu" );
    foreach (@IVRs) {
    	my %IVR = SarkSubs::SQLiteGetHash($dbh, "SELECT * FROM ivrmenu WHERE pkey = '$_'");
        my $IVRpkey = $IVR{pkey};
        while ( my ($key, $value) = each %IVR ) {
        	if ( $key =~ /option/ || $key eq 'timeout') {
                	if ($value eq $pkey) {
                                SarkSubs::SQLiteDo($dbh, "UPDATE ivrmenu SET $key='None' WHERE pkey='$IVRpkey'" );
                        }
                }
    	}
    }
    SarkSubs::SQLiteDelete($dbh,"DELETE FROM speed where pkey='$pkey'");
    SarkSubs::SQLiteCommit($dbh);
    SarkSubs::SQLiteDisconnect($dbh);

    showInitial ($q, "<font color = red>@{[SarkSubs::tt_display('Sarksystemmsg5')]}</font color = red><font color = black>");
}
