#!/usr/bin/perl

#----------------------------------------------------------------------
# heading     : Telephony
# description : SARK/SAIL splash
# navigation  : N/A
#
# Copyright (c) Aelintra.com 2007-10
#
#----------------------------------------------------------------------
#----------------------------------------------------------------------
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
#
# Technical support for this program is available from Selintra Ltd
# Please visit our web site www.selintra.com/ for details.
#----------------------------------------------------------------------

use lib '/opt/sark/perl/modules';
use strict;
use CGI ':all';
use CGI::Carp qw(fatalsToBrowser);
use sark::SarkSubs;

sub showInitial ($$);

BEGIN
{
    # Clear PATH and related environment variables so that calls to
    # external programs do not cause results to be tainted. See
    # "perlsec" manual page for details.

    $ENV {'PATH'} = '';
    $ENV {'SHELL'} = '/bin/bash';
    delete $ENV {'ENV'};
}

$< = $>;
$( = $);

$CGI::POST_MAX=1024 * 100;  # max 100K posts
$CGI::DISABLE_UPLOADS = 1;  # no uploads
my $pfile = "/opt/sark/passwd/passwords";


my $q = new CGI;

if (! grep (/^state$/, $q->param))  {
    showInitial ($q, '');
}
else {
    die "STATE ERROR!! ";
}
exit (0);


sub showInitial ($$)
{
    my ($q, $msg) = @_;
    SarkSubs::sark_header ($q);
    print h1( SarkSubs::tt_display('Sarksystemh11').($msg || 'SAIL Community Supported Release') );
    print '<hr class="hr" />';
    print "<br/>";
    print '<div style="width:100%;">';
    printSysNotes();
        print <<SHOWTUX;
        <span style="float: right;margin: 0 190px 0px 0px;">
        <img src="/sark-common/tux-with-a-phone.jpg"  alt="Telephone Tux">
	</span>

SHOWTUX

#    SarkSubs::printSysNotes();

#       <span style="position:relative; top:0px; left:200px">
    print '</div>';
    SarkSubs::sark_footer($q);

}

sub printSysNotes () {
#
#   prints sysinfo Tab
#
    print '<div  class="notes">';
    print '<p class="last">';

	my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime;
	$year += 1900;
	$mon += 1;
	my $systime = sprintf "%02d:%02d", $hour, $min;
    my $localIP			= SarkSubs::ret_localip();
    my $systemMode		= `/sbin/e-smith/config get SystemMode`;
    my $systemName		= `/bin/hostname`;
    my $domainName		= '';
#    my $externip		= ret_externip();
    my $snmask			= SarkSubs::ret_subnetmask();

    my $rlse       = `/bin/cat /opt/sark/.sail-release`;
    my @free = `/usr/bin/free`;
    my $uptime = `/usr/bin/uptime`;
    $uptime =~ /up\s(\d+\sdays)/;
    my $updays = $1;
    my $totmem, ;
    my $usedmem;
    my $freemem;
    my $sharedmem;
    my $buffers;
    my $cached;
    my $swaptot;
    my $swapused;
    my $swapfree;
    my @disk = `/bin/df -h`;
    $_ = $disk[2];
    /(\d{1,2}\%)/;
    my $diskusage = $1;
    my $systemMedia = 'disk';
    if (-e "/persistent") {
	$systemMedia = 'flash';
    }
    foreach (@free) {
	if (/Mem:\s+(\d{1,7})\s+(\d{1,7})\s+(\d{1,7})\s+(\d{1,7})\s+(\d{1,7})/) {
		$totmem = $1;
		$usedmem = $2;
		$freemem = $3;
		$sharedmem = $4;
		$buffers = $5;
	}
    }
    my $dbh = SarkSubs::SQLiteConnect();
    my $hasecnode = SarkSubs::SQLiteGetGlobal($dbh, 'HASECNODE');
    my $haclusterip = SarkSubs::SQLiteGetGlobal($dbh, 'HACLUSTERIP') || $localIP;
    my $extlen  = SarkSubs::SQLiteGetGlobal($dbh, 'EXTLEN');
    my $sno = rets();
    my $logopts = SarkSubs::SQLiteGetGlobal($dbh, 'LOGOPTS');
    my $runstate;
    my $harunstate;
    
    
    
    $ENV{SERVER_SOFTWARE} =~ '^(\w*)\b';
    my $server = $1;
    SarkSubs::SQLiteDisconnect($dbh);
    unless ( SarkSubs::check_pid() ) {
        $runstate = "STOPPED";
    }
    else {
        $runstate = "RUNNING";
    }
    if ( -e "/etc/init.d/heartbeat" ) {
    	unless ( SarkSubs::check_hapid() ) {
        	$harunstate = "STOPPED";
    	}
   	else {
        	$harunstate = "RUNNING";
    	}
    }
#
#   get the system type
#
    if ( -e "/etc/redhat-release" ) {
    	$_ = `/bin/cat /etc/redhat-release`;
    	/^(.*)beta.*$/;
    	my $stype = $1;
    }
#
#
#
    my $systate = "FULL";
    if ( -e "/opt/sark/.modeone") {
    		$systate = "DEMO";
    }

    print '<span style="color: #696969;" >';
    print '<span style="font-weight:bold; font-size:small; ">Sysinfo</span><br />';
    print "Serial #: <strong>$sno</strong><br/>";
    print "Release #: <strong>$rlse</strong><br/>";
#    print "Platform: <strong>$stype</strong><br/>";
    print "Web Server: <strong>$server</strong><br/>";
    $ENV{HTTP_USER_AGENT} =~ /(MSIE)/ ||
    	$ENV{HTTP_USER_AGENT} =~ /(Chrome)/ ||
        $ENV{HTTP_USER_AGENT} =~ /(Firefox)/;
    if ($1) {
    	print "Browser: <strong>$1</strong><br/>";
    }
    else {
        print "Browser: <strong>Unknown</strong><br/>";
    }
#    print '<br/>';
    print '<span style="font-weight:bold; font-size:small; ">Network</span><br />';
    print "hostname: <strong>$systemName</strong><br/>";
#    print "domain: <strong>$domainName</strong><br/>";
    print "LAN IP: <strong>$localIP</strong><br/>";
    if ( -e "/etc/init.d/heartbeat"  && $harunstate eq "RUNNING" ) {
        print "HAE IP: <strong>$haclusterip</strong><br/>";
    }
    print "Netmask: <strong>$snmask</strong><br/>";
#    print '<br/>';
    print '<span style="font-weight:bold; font-size:small; ">Hardware</span><br />';
    print "System Media: <strong>$systemMedia</strong><br/>";
    unless ( -e "/persistent" ) {
        print "Disk Usage: <strong>$diskusage</strong><br/>";
    }
    print "RAM Size: <strong>$totmem</strong><br/>";
    print "RAM Free: <strong>$freemem</strong><br/>";
#    print '<br/>';
    print '<span style="font-weight:bold; font-size:small; ">Status</span><br />';
    print "PBX State: <strong>$runstate</strong><br/>";
    if ( -e "/etc/init.d/heartbeat" ) {
        print "HAE State: <strong>$harunstate</strong><br/>";
    }
    print "SysTime: <strong>$systime</strong><br/>";
    if ($updays) {
    	print "System Uptime: <strong>$updays</strong><br/>";
    }
    print "</p>\n";
    print '</span>';
    print "</div>\n";

}

sub rets() {
  if (-e "/persistent") {
	if ( ! -e "/opt/sark/db/.sark-install-date" ) {
		`/bin/date > /opt/sark/db/.sark-install-date`;
	}
  }
  my $dir = "/opt/sark/passwd";
  my @list = <$dir/.*>;
  my $flg = 0;
  foreach (@list) {
        if (/\.(\d+)$/) {
                $flg = $1;
                last;
        }
  }
  unless ($flg) {
        $flg = int(rand(1000000));
        open( FH,">$dir/.$flg" )
                or die "Can't create: $!";
        close(FH);
  }
  return $flg;
}
